package cz.upol.jj1.generics.basics;

import java.math.BigDecimal;

public class Demo<U> {
    public static void main(String[] args) {
        //krabicka pro integery
        BoxInt bi = new BoxInt(1);


        //obecnejsi krabicka (double zvladne i int, ale chovani je trochu jine...)
        BoxDouble bd1 = new BoxDouble(1);
        BoxDouble bd2 = new BoxDouble(1.0);

        //jeste obecnejsi krabicka (Number je predek vsech cisel)
        BoxNumber bn1 = new BoxNumber(1);
        BoxNumber bn2 = new BoxNumber(1.0);
        BoxNumber bn3 = new BoxNumber(new BigDecimal(1));

        //obsah krabicky jako double
        System.out.println(bn2.getValue().doubleValue());

        //krabicka pro pole je uz ale uplne jina...
        BoxArray ba = new BoxArray(new int[]{1, 1, 1});

        //krabicka pro object to zdanlive resi, ...
        BoxObject bo1 = new BoxObject(1);
        BoxObject bo2 = new BoxObject(1.0);
        BoxObject bo3 = new BoxObject(new BigDecimal(1));
        BoxObject bo4 = new BoxObject(new int[]{1, 1, 1});


        //... ale ...
        int bo1Val = (int) bo1.getValue();
        double bo2Val = (double) bo2.getValue();
        BigDecimal bo3Val = (BigDecimal) bo3.getValue();
        int[] bo4Val = (int[]) bo4.getValue();
        //... toto je dost nachylne k chybam
        // programator si musi pamatovat, kam co dal
        // realne se vzdavame typove kontroly


        //mimo to si vsimnete, ze vsechny krabicky maji skoro stejny kod
        // - lisi se jen v typech

        // generika - jedna genericka trida
        // nam diky pridani typoveho parametru
        // umozni "generovat" vsechny tridy vyse na pozadani

        //diamond notation pri vytvareni instance
        GenericBox<Integer> gbi1 = new GenericBox<>(1);

        GenericBox<Double> gbd1 = new GenericBox<>(Double.valueOf(1));
        GenericBox<Double> gbd2 = new GenericBox<>(1.0);

        GenericBox<Number> gbn1 = new GenericBox<>(1);
        GenericBox<Number> gbn2 = new GenericBox<>(1.0);
        GenericBox<Number> gbn3 = new GenericBox<>(new BigDecimal(1));

        GenericBox<int[]> gba1 = new GenericBox<>(new int[]{1, 1, 1});

        GenericBox<Object> gbo1 = new GenericBox<>(1);
        GenericBox<Object> gbo2 = new GenericBox<>(1.0);
        GenericBox<Object> gbo3 = new GenericBox<>(new BigDecimal(1));
        GenericBox<Object> gbo4 = new GenericBox<>(new int[]{1, 1, 1});

        //tedy misto peti ruznych krabic, nam staci jeden predpis pro krabice
        //a kdyz nekdo bude chtit krabici, tak si rekne pro jaky typ

        //typicky priklad pouziti jsou kolekce - vizte dale
        //ale pouziva se vsude a casto


        }

        public void limits() {
            //pozor generika neni vsemocna
            // - prace s poli ma omezeni, da se snadno obejit kolekcemi (priste)
            GenericBox<Integer>[] intBoxes; //typove ok
           // intBoxes = new GenericBox<Integer>[]{}; //ale takoveto vytvoreni generickeho pole neprojde
            // - nelze instanciovat primo typovy parametr (U pridame jako typovy parametr tridy main)
            U typeUVariable;

            //typeUVariable = new U(); //vytvorit objekt genrickeho typu takto nelze

        }
        // - nelze vytvaret staticke rference na genericky parametr
        //static U attr;


}
