package cz.upol.jj1.generics.comparable;


//stejna krabicka jako predtim, ale ted navic muzeme krabicky porovnavat podle jejich obsahu

/**
 * What a nice box! It has just the shape I need.
 * And it can be compared too!
 * @param <T> Type the box is made for.
 */
public class GenericBox<T extends Comparable<T>> implements Comparable<GenericBox<T>> {

    private T value;

    public GenericBox(T value) {
        this.value = value;
    }

    /**
     * Let's check what's inside.
     * @return Content of the box.
     */
    public T getValue() {
        return value;
    }

    /**
     * Let's store something here.
     * Spooky: what happens to the thing already there?!
     * @param value The thing tobe stored in this box.
     */
    public void setValue(T value) {
        this.value = value;
    }

    /**
     * Boxes are compared by their content.
     * @param o the box to be compared.
     * @return
     */
    @Override
    public int compareTo(GenericBox<T> o) {
        if (value == null) {
            if (o == null || o.value == null) {
                return 0;
            } else {
                return -1;
            }
        }
        if (o == null) {
            return 1;
        }
        return this.value.compareTo(o.value);
    }
}
