package cz.upol.jj1.generics.optional;

import java.util.Optional;

public class Demo {

    public static void main(String[] args) {
        Optional<String> optionalName = getAgentsName(10);

        //to, ze metoda vraci Optional je silny naznak toho, ze bych se mel ujistit,
        //zda hodnota skutecne existuje
        if (optionalName.isPresent())
        {
            System.out.println(optionalName.get());
        } else {
            System.out.println("Does (s)he even exist?");
        }
    }


    /**
     * Get name of 00 agent, if it is known.
     * @param val agent's number
     * @return agent's name if it is known
     */
    public static Optional<String> getAgentsName(int val){
        String name = switch (val) {
            case 6, 9, 11 -> "unnamed";
            case 7 -> "Bond, James Bond";
            case 8 -> "Bill";
            default -> null;
        };
        //return Optional.of(name); //pokud name je null skonci vyjimkou
        return Optional.ofNullable(name); //pokud name je null tak vrati Optional.empty()
    }
}
